Clus_HOSE <- function(data){
if (!require("stringdist")) {
  install.packages("stringdist", dependencies=T)
}
if (!require("ape")) {
  install.packages("ape", dependencies=T)
}
require("stringdist")
require("ape")
N <- length(data)
MAT <- matrix(0,N,N)
for(i in 1: N)
for(j in i:N)
MAT[i,j] <- stringdist(data[i], data[j],method="lv")
MAT <- t(MAT)
colnames(MAT) <- data
rownames(MAT) <- data
distMAT <- as.dist(MAT)
clustMAT <- hclust(distMAT)
phyloMAT <- as.phylo(clustMAT)
par(mar=c(3, 0, 0, 0))
plot.phylo(phyloMAT)
axisPhylo()
}
