TesHistAli <- function(HSQC,HSQCTOCSY,COSY1H,COSY13C,bwH=0.01,bwC=0.01,N=1024,noiseH,noiseC){
bwH <<- bwH 				# 1H band wide
bwC <<- bwC				# 13C band wide
N <<- N					# number of point
noiseH <<- noiseH			# 1H noise level
noiseC <<- noiseC			# 13C noise level
hsqc <- as.matrix(HSQC[,2:3])
hsqctocsy <- as.matrix(HSQCTOCSY[,2:3])
cosy1h <- as.matrix(COSY1H[,2:3])
cosy13c <- as.matrix(COSY13C[,2:3])
HH <- rbind(-1,matrix(hsqc[,1]),matrix(hsqctocsy[,1]),matrix(cosy1h[,1]),matrix(cosy1h[,2]),11)		# -1 & 11 are dummy
CC <- rbind(-10,matrix(hsqc[,2]),matrix(hsqctocsy[,2]),matrix(cosy13c[,1]),matrix(cosy13c[,2]),210)	# -10 & 210 are dummy 
Hden <- density(HH, bw=bwH, n=N)
Cden <- density(CC, bw=bwC, n=N)
dev.set(1)
plot(Hden,xlim=c(0,10))
rug(HH)
dev.set(1)
plot(Cden,xlim=c(0,200))
rug(CC)
Hhist <- rbind(Hden$x,Hden$y)
Chist <- rbind(Cden$x,Cden$y)
LEN1 <- length(Hden$x)-1
LEN2 <- length(Cden$x)-1
Htop3 <- c()
Ctop3 <- c()
for(i in 2:LEN1)
if( Hhist[2,i-1] < Hhist[2,i] && Hhist[2,i] > Hhist[2,i+1]){
Htop3 <- c(Htop3,Hhist[2,i])
}
windows()
plot(sort(Htop3))
abline(h=noiseH)
for(i in 2:LEN2)
if( Chist[2,i-1] < Chist[2,i] && Chist[2,i] > Chist[2,i+1]){
Ctop3 <- c(Ctop3,Chist[2,i])
}
windows()
plot(sort(Ctop3))
abline(h=noiseC)
}
