angle3D <- function(A,B,C,D){
BA <- c(A[1]-B[1],A[2]-B[2],A[3]-B[3])
BC <- c(C[1]-B[1],C[2]-B[2],C[3]-B[3])
CB <- c(B[1]-C[1],B[2]-C[2],B[3]-C[3])
CD <- c(D[1]-C[1],D[2]-C[2],D[3]-C[3])

N1 <- c(BA[2]*BC[3] - BA[3]*BC[2], BA[3]*BC[1] - BA[1]*BC[3], BA[1]*BC[2] - BA[2]*BC[1])	# normal vector
N2 <- c(CB[2]*CD[3] - CB[3]*CD[2], CB[3]*CD[1] - CB[1]*CD[3], CB[1]*CD[2] - CB[2]*CD[1])	# normal vector

theta <- ((N1[1]*N2[1])+(N1[2]*N2[2])+(N1[3]*N2[3]))/(sqrt(((N1[1]^2)+(N1[2]^2)+(N1[3]^2))*((N2[1]^2)+(N2[2]^2)+(N2[3]^2))))	# radian
angle <- (acos(theta))*180/pi	# angle

NN <- c(N1[2]*N2[3] - N1[3]*N2[2], N1[3]*N2[1] - N1[1]*N2[3], N1[1]*N2[2] - N1[2]*N2[1])
coef <- ((BC[1]*NN[1])+(BC[2]*NN[2])+(BC[3]*NN[3]))/(sqrt(((BC[1]^2)+(BC[2]^2)+(BC[3]^2))*((NN[1]^2)+(NN[2]^2)+(NN[3]^2))))	# direction (1 or -1)

ANGLE <- angle*coef
ANGLE
}
