dRMS <- function(dDATA, dDATA2, ang=30){	# dDATA & dDATA2 = dihedral angle data, ang = cut off
Ddata <- dDATA
N <- dim(dDATA)[2]-1				# number of dihedral angle
M <- dim(dDATA)[1]				# number of coordinate
dDATA <- as.matrix(dDATA[,-dim(dDATA)[2]])
dDATA2 <- as.matrix(dDATA2[,-dim(dDATA2)[2]])
rownames(Ddata) <- seq(1:M)
simi <- c()
for(i in 1:M){
for(j in i:M){
DDATA <- matrix(0,2,N)
DDATA[1,] <- (dDATA[i,]-dDATA[j,])^2
DDATA[2,] <- (dDATA2[i,]-dDATA2[j,])^2
DDATA2 <- apply(DDATA,2,min)
if(i != j && sqrt(sum(DDATA2)/N) < ang){
simi <- append(simi,j)
}}}
if(!is.null(simi)){
DEL <- sort(unique(simi))
Ddata <- Ddata[-DEL,]
} else {
Ddata <- Ddata
}
RES <- list()
RES$summary <- matrix(0,1,3)
colnames(RES$summary) <- c("all","RES","delete")
RES$summary[1,1] <- M
RES$summary[1,2] <- L <- dim(Ddata)[1]
RES$summary[1,3] <- M-L
res <- seq(1:M)
if(!is.null(simi)){
RES$RES <- res[-DEL]
} else {
RES$RES <- res
}
colnames(Ddata) <- seq(1:dim(Ddata)[2])
colnames(Ddata)[dim(Ddata)[2]] <- c("Energy")
write.csv(Ddata,"Ddata.csv")
print(RES$summary)
RES
cat("Result is exported under ",'"',getwd(),'"',"\n\n",sep="")
}
