HistAli <- function(HSQC,HSQCTOCSY,COSY1H,COSY13C,bwH,bwC,noiseH,noiseC,N){
hsqc <- as.matrix(HSQC[,2:3])
hsqctocsy <- as.matrix(HSQCTOCSY[,2:3])
cosy1h <- as.matrix(COSY1H[,2:3])
cosy13c <- as.matrix(COSY13C[,2:3])
HH <- rbind(-1,matrix(hsqc[,1]),matrix(hsqctocsy[,1]),matrix(cosy1h[,1]),matrix(cosy1h[,2]),11)		# -1 & 11 are dummy
CC <- rbind(-10,matrix(hsqc[,2]),matrix(hsqctocsy[,2]),matrix(cosy13c[,1]),matrix(cosy13c[,2]),210)	# -10 & 210 are dummy 
Hden <- density(HH, bw=bwH, n=N)
Cden <- density(CC, bw=bwC, n=N)
Hhist <- rbind(Hden$x,Hden$y)
Chist <- rbind(Cden$x,Cden$y)
Htop <- c()
Htop2 <- c()
Hsep <- c()
Hsep2 <- c()
LEN1 <- length(Hden$x)-1
Hhist[2,which(Hhist[2,] < noiseH)]<-0
for(i in 2:LEN1)
if( Hhist[2,i-1] < Hhist[2,i] && Hhist[2,i] > Hhist[2,i+1] && Hhist[1,i] < 10 && Hhist[1,i] > 0 ){
Htop <- c(Htop,Hhist[1,i])						# 1H peak top 
Htop2 <- c(Htop2,i)
} 
for(i in 2:LEN1)
if( Hhist[1,i] < 10 && Hhist[1,i] > 0 ){
if( (Hhist[2,i-1] > Hhist[2,i] && Hhist[2,i] < Hhist[2,i+1]) || (Hhist[2,i-1] > 0 && Hhist[2,i]==0) ){
Hsep <- c(Hsep,Hhist[1,i])
Hsep2 <- c(Hsep2,i)							# 1H separation boundary
}}
Href <- as.matrix(Htop)
Hsep3 <- as.matrix(Hsep)
len2 <- dim(Hsep3)[1]
Hsep4 <- c(-1,Hsep)
Hsep4 <- Hsep4[-(len2+1)]
Hsep4 <- as.matrix(Hsep4)
Href <- cbind(Href,Hsep4[1:len2,1])
Href <- cbind(Href,Hsep3[1:len2,1])					# 1H alignment list
len <- dim(Href)[1]
for(i in 1:len)
for(j in 1:dim(hsqc)[1])
if( Href[i,2] < hsqc[j,1] && hsqc[j,1] <= Href[i,3] ){			# HSQC 1H alignment
hsqc[j,1] <- Href[i,1]
}else if( hsqc[j,1] < Href[1,2] ){
hsqc[j,1] <- Hhist[1,1]
}
for(i in 1:len)
for(j in 1:dim(hsqctocsy)[1])
if( Href[i,2] < hsqctocsy[j,1] && hsqctocsy[j,1] <= Href[i,3] ){	# hsqctocsy 1H alignment
hsqctocsy[j,1] <- Href[i,1]
}else if( hsqctocsy[j,1] < Href[1,2] ){
hsqctocsy[j,1] <- Hhist[1,1]
}
for(i in 1:len)
for(j in 1:dim(cosy1h)[1])
if( Href[i,2] < cosy1h[j,1] && cosy1h[j,1] <= Href[i,3] ){		# cosy 1H alignment
cosy1h[j,1] <- Href[i,1]
}else if( cosy1h[j,1] < Href[1,2] ){
cosy1h[j,1] <- Hhist[1,1]
}
for(i in 1:len)
for(j in 1:dim(cosy1h)[1])
if( Href[i,2] < cosy1h[j,2] && cosy1h[j,2] <= Href[i,3] ){		# cosy 1H alignment
cosy1h[j,2] <- Href[i,1]
}else if( cosy1h[j,2] < Href[1,2] ){
cosy1h[j,2] <- Hhist[1,1]
}
Ctop <- c()
Csep <- c()
Ctop2 <- c()
Csep2 <- c()
LEN2 <- length(Cden$x)-1
Chist[2,which(Chist[2,] < noiseC)]<-0
for(i in 2:LEN2)
if( Chist[2,i-1] < Chist[2,i] && Chist[2,i] > Chist[2,i+1] && Chist[1,i] < 205 && Chist[1,i] > -5  ){
Ctop <- c(Ctop,Chist[1,i])
Ctop2 <- c(Ctop2,i)							# 13C peak top
} 
for(i in 2:LEN2)
if( Chist[1,i] < 205 && Chist[1,i] > -5 ){
if( (Chist[2,i-1] > Chist[2,i] && Chist[2,i] < Chist[2,i+1]) || (Chist[2,i-1] > 0 && Chist[2,i]==0) ){
Csep <- c(Csep,Chist[1,i])						# 13C separation boundary
Csep2 <- c(Csep2,i)
}}
Cref <- as.matrix(Ctop)
Csep3 <- as.matrix(Csep)
len2 <- dim(Csep3)[1]
Csep4 <- c(-1,Csep)
Csep4 <- Csep4[-(len2+1)]
Csep4 <- as.matrix(Csep4)
Cref <- cbind(Cref,Csep4[1:len2,1])
Cref <- cbind(Cref,Csep3[1:len2,1])					# 13C alignment list
len <- dim(Cref)[1]
for(i in 1:len)
for(j in 1:dim(hsqc)[1])
if( Cref[i,2] < hsqc[j,2] && hsqc[j,2] <= Cref[i,3] ){			# HSQC 13C alignment
hsqc[j,2] <- Cref[i,1]
}else if( hsqc[j,2] < Cref[1,2] ){
hsqc[j,2] <- Chist[1,1]
}
for(i in 1:len)
for(j in 1:dim(hsqctocsy)[1])
if( Cref[i,2] < hsqctocsy[j,2] && hsqctocsy[j,2] <= Cref[i,3] ){	# hsqctocsy 13C alignment
hsqctocsy[j,2] <- Cref[i,1]
}else if( hsqctocsy[j,2] < Cref[1,2] ){
hsqctocsy[j,2] <- Chist[1,1]
}
for(i in 1:len)
for(j in 1:dim(cosy13c)[1])
if( Cref[i,2] < cosy13c[j,2] && cosy13c[j,2] <= Cref[i,3] ){		# cosy 13C alignment
cosy13c[j,2] <- Cref[i,1]
}else if( cosy13c[j,2] < Cref[1,2] ){
cosy13c[j,2] <- Chist[1,1]
}
for(i in 1:len)
for(j in 1:dim(cosy13c)[1])
if( Cref[i,2] < cosy13c[j,1] && cosy13c[j,1] <= Cref[i,3] ){		# cosy 13C alignment
cosy13c[j,1] <- Cref[i,1]
}else if( cosy13c[j,2] < Cref[1,2] ){
cosy13c[j,1] <- Chist[1,1]
}
RES <- list()
RES$hsqc <- cbind(seq(1:dim(hsqc)[1]),hsqc)
RES$hsqctocsy <- cbind(seq(1:dim(hsqctocsy)[1]),hsqctocsy)
RES$cosy1h <- cbind(seq(1:dim(cosy1h)[1]),cosy1h)
RES$cosy13c <- cbind(seq(1:dim(cosy13c)[1]),cosy13c)
HH2 <- rbind(-1,matrix(hsqc[,1]),matrix(hsqctocsy[,1]),matrix(cosy1h[,1]),matrix(cosy1h[,2]),11)
CC2 <- rbind(-10,matrix(hsqc[,2]),matrix(hsqctocsy[,2]),matrix(cosy13c[,1]),matrix(cosy13c[,2]),210)
Hden2 <- density(HH2, bw=bwH, n=N)
Cden2 <- density(CC2, bw=bwC, n=N)
dev.set(1)
par(mfrow=c(2,1))
plot(Hden,xlim=c(0,10),ylim=c(0,max(Hhist[2,])))
rug(HH)
par(new=T)
plot(Hhist[1,Htop2],Hhist[2,Htop2],xlim=c(0,10),ylim=c(0,max(Hhist[2,])))
abline(v= Hhist[1,Hsep2],lty=2,col="red")
plot(Hden2,xlim=c(0,10))
rug(HH2)
dev.set(1)
par(mfrow=c(2,1))
plot(Cden,xlim=c(0,200),ylim=c(0,max(Chist[2,])))
rug(CC)
par(new=T)
plot(Chist[1,Ctop2],Chist[2,Ctop2],xlim=c(0,200),ylim=c(0,max(Chist[2,])))
abline(v= Chist[1,Csep2],lty=2,col="red")
plot(Cden2,xlim=c(0,200))
rug(CC2)
return(RES)
}
