ProjAli <- function(HSQC,HSQCTOCSY,COSY1H,COSY13C,Hali,Cali)
{
Hali <- as.matrix(Hali)
Cali <- as.matrix(Cali)
HSQC <- as.matrix(HSQC)
HSQCTOCSY <- as.matrix(HSQCTOCSY)
COSY1H <- as.matrix(COSY1H)
COSY13C <- as.matrix(COSY13C)
dHali <- dim(Hali)[1]
dCali <- dim(Cali)[1]
dHSQC <- dim(HSQC)[1]
dHSQCTOCSY <- dim(HSQCTOCSY)[1]
dCOSY1H <- dim(COSY1H)[1]
dCOSY13C <- dim(COSY13C)[1]

# 1H processing
for(i in 1:dHali)
for(j in 1:dHSQC)
if( Hali[i,2] < HSQC[j,2]  && HSQC[j,2] <= Hali[i,3] ){
HSQC[j,2] <- Hali[i,4]
}
for(i in 1:dHali)
for(j in 1:dHSQCTOCSY)
if( Hali[i,2] < HSQCTOCSY[j,2]  && HSQCTOCSY[j,2] <= Hali[i,3] ){
HSQCTOCSY[j,2] <- Hali[i,4]
}
for(i in 1:dHali)
for(j in 1:dCOSY1H)
if( Hali[i,2] < COSY1H[j,1]  && COSY1H[j,1] <= Hali[i,3] ){
COSY1H[j,1] <- Hali[i,4]
}
for(i in 1:dHali)
for(j in 1:dCOSY1H)
if( Hali[i,2] < COSY1H[j,2]  && COSY1H[j,2] <= Hali[i,3] ){
COSY1H[j,2] <- Hali[i,4]
}

# 13C processing
for(i in 1:dCali)
for(j in 1:dHSQC)
if( Cali[i,2] < HSQC[j,3]  && HSQC[j,3] <= Cali[i,3] ){
HSQC[j,3] <- Cali[i,4]
}
for(i in 1:dCali)
for(j in 1:dHSQCTOCSY)
if( Cali[i,2] < HSQCTOCSY[j,3]  && HSQCTOCSY[j,3] <= Cali[i,3] ){
HSQCTOCSY[j,3] <- Cali[i,4]
}
for(i in 1:dCali)
for(j in 1:dCOSY13C)
if( Cali[i,2] < COSY13C[j,1]  && COSY13C[j,1] <= Cali[i,3] ){
COSY13C[j,1] <- Cali[i,4]
}
for(i in 1:dCali)
for(j in 1:dCOSY13C)
if( Cali[i,2] < COSY13C[j,2]  && COSY13C[j,2] <= Cali[i,3] ){
COSY13C[j,2] <- Cali[i,4]
}

RES <- list()
RES$HSQC <- HSQC
RES$HSQCTOCSY <- HSQCTOCSY
RES$COSY1H <- COSY1H
RES$COSY13C <- COSY13C
return(RES)
}
